# -*- coding: iso-8859-1 -*-
## ----------------------------------------------------------------------
## PyCoinCoin - Plug-in Boitakon
## ----------------------------------------------------------------------

import logging
log = logging.getLogger('pycc')
import sys
sys.path.append('..')
from coinlib.plugin import *
from cointklib.dialogs import *
from coinlib.utils import apply_styles
# from coinlib.persistants import Option, OptionSet
# from cointklib.basicwidgets import *
# from cointklib.widgets import OptionsEditor

def build_plugins(pycc):
  return { \
    'boitakon': Boitakon(pycc, "Boitakon", "Enferme les posts indsirables dans la Boitakon(r)(tm)")
  }

class BAKDialog(CoinDialog):
  
  def __init__(self, plugin, trib):
    self.plugin = plugin
    self.trib = trib
    CoinDialog.__init__(self, trib.bouchot.pycc.root, "pyCoinCoin - Boitakon", ['Librer les posts', 'Fermer'], 0)
  
  def bind_button(self, button):
    return self.unbak
  
  def unbak(self, event=None):
    self.plugin.unbak(self.trib)
    self.cancel()
  
  def body(self, master):
    Label(master, text="Posts enferms dans la Boitakon", background="#FCFCDA").pack(fill=X)
    self.txt = ScrolledText(master, wrap=WORD)
    self.txt.pack(fill=BOTH, expand=1)
    self.txt.bind("<Enter>", lambda e, w=self.txt: w.focus_set())
    self.txt.config(cursor="arrow")
    apply_styles(self.txt, self.trib.bouchot.styles)
    nbposts = self.show_posts()
    Label(master, text="Total: %s posts"%nbposts).pack(anchor=W)
  
  def show_posts(self):
    self.txt.config(state=NORMAL)
    self.txt.delete(0.0, END)
    if not hasattr(self.trib, "baked_posts"): return 0
    # On recre la liste des posts car si on utilisait directement trib.posts, le tableau
    # risque de changer pendant le calcul (vu qu'a priori le thread de polling de la
    # tribune continue de tourner pendant l'excution du plugin)
    postlist = [p for p in self.trib.baked_posts]
    postlist.sort()
    # cpt = 0
    for p in postlist:
      # if 'boitakon' not in p.status: continue
      # cpt += 1
      text, tags = self.trib.formatPost(p, ['id']+self.trib.options.val('disp_post_attrs'))
      self.txt.mark_set(INSERT, END)
      index = self.txt.index(INSERT)
      self.txt.insert(END, text)
      for tag in tags.keys():
        for range in tags[tag]:
          self.txt.tag_add(tag, "%s+%s chars" % (index, range[0]), "%s+%s chars" % (index, range[1]))
    self.txt.config(state=DISABLED)
    return len(postlist)

class Boitakon(Plugin):
  
  def action_menu(self):
    cur_trib = self.pycc.bouchots[self.pycc.get_bouchot()].trib
    if cur_trib is None or not cur_trib.loaded: return
    BAKDialog(self, cur_trib)
  
  def unbak(self, trib):
    if not hasattr(trib, "baked_posts"): return
    for post in trib.baked_posts:
      ppost = post.prev
      npost = post.next
      if ppost is not None:
        post.next = ppost.next
        ppost.next = post
      if npost is not None:
        post.prev = npost.prev
        npost.prev = post
      trib.posts[post.id] = post
      if npost is None:
        trib.pinni.addPost(post)
      else:
        trib.pinni.insertPost(post, npost)
        trib.refresh_post(post)
    trib.baked_posts = []
  
  def process(self, bouchot, context=PINNI, post=None, *args, **kwargs):
    if post is None: return
    ppost = post.prev
    npost = post.next
    if ppost is not None:
      ppost.next = npost
    if npost is not None:
      npost.prev = ppost
    try:
      bouchot.trib.baked_posts.append(post)
    except:
      bouchot.trib.baked_posts = [post]
    if post.id == bouchot.trib.firstPostId:
      bouchot.trib.firstPostId = npost.id
    if post.id == bouchot.trib.lastPostId:
      bouchot.trib.lastPostId = ppost.id
    del bouchot.trib.posts[post.id]
    bouchot.trib.pinni.delPost(post.id)
  