# -*- coding: iso-8859-1 -*-
## ----------------------------------------------------------------------
## PyCoinCoin - Plug-in URLDumper
## ----------------------------------------------------------------------

import logging
log = logging.getLogger('pycc')
import sys
sys.path.append('..')
from Tkinter import *
from ScrolledText import ScrolledText

from coinlib.plugin import *
from cointklib.basicwidgets import SplashWindow
from cointklib.dialogs import CoinTopLevel
from coinlib.utils import *

def build_plugins(pycc):
  return { \
    'urld': URLDumper(pycc, "URL dumper (antibloub)", "Retourne les URLs collectes dans le coincoin")
  }


class UDDialog(CoinTopLevel):
  
  def __init__(self, pycc):
    self.pycc = pycc
    CoinTopLevel.__init__(self, pycc.root, "pyCoinCoin - AntiBloub URL Dumper", [ 'Fermer' ])
  
  def body(self, master):
    title = Label(master, background="#fcfcda", text=u"Liste des URLs collectes")
    title.pack(pady=3, fill=X)
    self.list = ScrolledText(master, wrap=WORD)
    self.list.pack(fill=BOTH, expand=1)
    self.list.bind("<Enter>", lambda e, w=self: w.list.focus_set())
    self.list.bind("<Motion>", self.mouse_move)
    self.list.bind("<1>", self.mouse_click)
    self.list.bind("<2>", self.mouse_click2)
    self.fillList()
    apply_styles(self.list, self.pycc.bouchots[self.pycc.get_bouchot()].styles)
  
  def fillList(self):
    self.list.config(state='normal')
    self.list.delete('0.0', 'end')
    tmplist = []
    for url in self.pycc.urllist.keys():
      refs, read = self.pycc.urllist[url]
      for ref in refs:
        time, bouchot = ref.split("@")
        tmplist.append((bouchot, time, url, read))
    tmplist.sort()
    bufbouchot = ""
    for bouchot, time, url, read in tmplist:
      if bouchot != bufbouchot:
        bufbouchot = bouchot
        self.list.insert('insert', u"URLs sur %s\n" % bouchot, "hilight")
      self.list.insert('insert', "   ")
      self.list.insert('insert', time, "time")
      self.list.insert('insert', " ")
      start = self.list.index("insert")
      self.list.insert('insert', url, "a")
      if read:
        self.list.tag_add("urlvisit", start, "%s+%s chars" % (start, len(url)))
      self.list.tag_add("url_%s" % url, start, "%s+%s chars" % (start, len(url)))
      self.list.insert('insert', "\n")
    self.list.config(state='disabled')
  
  def setStyleTag(self, tag, style):
    tseq = self.list.tag_ranges(tag)
    cpt = 0
    while cpt < len(tseq):
      self.list.tag_add(style, tseq[cpt], tseq[cpt+1])
      cpt += 2
  
  def unhilight(self, event=None):
    """ Enlve les surbrillances """
    self.list.tag_remove("urlhilight", 1.0, END)
    self.list.config(cursor="arrow")
    self.pycc.setStatus("")
  
  def mouse_move(self, event):
    self.unhilight()
    tags = self.list.tag_names("@%d,%d" % (event.x, event.y))
    for t in tags:
      if t[:4] == "url_" or t[:4] == "img_":
        self.pycc.setStatus(t[4:])
        self.setStyleTag(t, "urlhilight")
        self.list.config(cursor="hand2")
  
  def mouse_click2(self, event):
    self.mouse_click(event, 2)
  
  def mouse_click(self, event, but=1):
    tags = self.list.tag_names("@%d,%d" % (event.x, event.y))
    for t in tags:
      if t[:4] == "url_":
        url = t[4:]
        if but == 1:
          self.pycc.openBrowser(url)
          self.setStyleTag(t, "urlvisit")
          self.pycc.setUrlRead(url)
        else:
          self.pycc.palmi.palmi.inserter(url, None, 0)
          self.pycc.palmi.tabselect('Message')
          self.pycc.palmi.palmi.focus_set()
          self.pycc.clipboard = url


class BloubInfo(SplashWindow):

  def __init__(self, pycc, bouchot, post, url):
    self.pycc = pycc
    self.bouchot = bouchot
    SplashWindow.__init__(self, pycc.root, post, url)
  
  def body(self, post, url):
    self.title = Label(self._splash, text="AntiBloub Info", cursor="arrow", background="#F0F0FF", font="Helvetica 9 bold")
    self.title.bind("<ButtonRelease>", self.destroy)
    self.title.pack(fill=X)
    refs, read = self.pycc.getBloub(url)
    texti = textp = ""
    for ref in refs:
      if ref == post.dispDateTimeRef(): #+"@"+self.bouchot.name):
        continue
      time, trib = ref.split("@")
      if time and trib == self.bouchot.name:
        textp += u" %s" % time
      else:
        textp += u" %s" % ref
      texti += u"\nsur %s" % trib
      if time:
        texti += u" ( %s)" % time
    if textp:
      textp = u"%s bloub, url dj poste%s" % (post.dispTimeRef(), textp)
      texti = u"URL dj poste%s" % texti
    self.text = Label(self._splash, text=texti, cursor="arrow", background="#FFEAA0")
    self.text.bind("<ButtonRelease>", self.destroy)
    self.text.pack(fill=BOTH, expand=1)
    self.copypalmi = Label(self._splash, text="Blouber %s" % post.login, cursor="hand2", foreground="#000080", background="#FFEAA0")
    self.copypalmi.bind("<ButtonRelease-1>", lambda ev, s=self, t=textp: s.blouber(t))
    self.copypalmi.bind("<Button-1>", lambda ev, s=self.copypalmi: s.config(relief=SUNKEN))
    self.copypalmi.bind("<Enter>", lambda ev, s=self.copypalmi: s.config(relief=RAISED))
    self.copypalmi.bind("<Leave>", lambda ev, s=self.copypalmi: s.config(relief=FLAT))
    self.copypalmi.pack(fill=X, expand=1, anchor=SE)
  
  def blouber(self, text):
    self.bouchot.trib.insertTextPalmi(text)
    self.destroy()

class URLDumper(Plugin):

  def action_menu(self):
    UDDialog(self.pycc)
  
  def process(self, bouchot, context, post=None, keyword=None, ctxt_tags=[], *args, **kwargs):
    if not post:
      return
    url = ""
    for t in ctxt_tags:
      if t[:4] == "url_":
        url = t[4:]
    if not url:
      return
    BloubInfo(self.pycc, bouchot, post, url)
  
